/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Timing routines                                                        *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#ifdef OS_2
#define INCL_NOPM
#include <os2.h>
#endif

#include <dos.h>
#include "prog.h"

long timerset(unsigned int duration)
{
#ifdef OS_2
    DATETIME dt;
    DosGetDateTime(&dt);
    return ( ((dt.minutes % 60)*6000L) +
             ((dt.seconds % 60)*100L) +
             dt.hundredths +
             (long)duration
            );
#else
#ifdef __MSC__
    struct dostime_t dt;
    _dos_gettime(&dt);
    return ( ((dt.minute % 60)*6000L) +
             ((dt.second % 60)*100L) +
             dt.hsecond +
             (long)duration
            );
#else /* assume generic MSDOS compiler */
    union REGS regs;
    regs.h.ah = 0x2c;
    intdos(&regs, &regs);
    return ( ((regs.h.cl % 60)*6000L) +
             ((regs.h.dh % 60)*100L) +
             regs.h.dl +
             (long)duration
            );
#endif
#endif
}

int timeup(long timer)
{
  long now;

  now=timerset (0);

  if (now < (timer-65536L))
    now += 360000L;

  return ((now-timer) >= 0L);
}


void timer(unsigned int duration)
{
  long tim;

  tim=timerset(duration);

  while (! timeup(tim))
    ;
}


